/*
 * segatex SELinux tool.
 *
 * Copyright (C) 2007 Shintaro Fujiwara 
 * shintaro.fujiwara@gmai.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * */

#include "parselines_selpaw_types.h"

//for debug
//#include <iostream>
//using namespace std;

//default constructor
ParseLinesSelpawTypes::ParseLinesSelpawTypes(){}
//constructor for Layout
ParseLinesSelpawTypes::ParseLinesSelpawTypes(QSplitter*&){}

void ParseLinesSelpawTypes::selpaw_admin_types()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_admin_types.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_admin.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "admin";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				////////////////////////////////////////////
				int i,j = -1;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_admin

void ParseLinesSelpawTypes::selpaw_apps_types()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_apps_types.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_apps.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "apps";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				////////////////////////////////////////////
				int i,j = -1;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_apps

void ParseLinesSelpawTypes::selpaw_kernel_types()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_kernel_types.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_kernel.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "kernel";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				////////////////////////////////////////////
				int i,j = -1;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_kernel

void ParseLinesSelpawTypes::selpaw_services_types()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_services_types.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_services.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "services";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				////////////////////////////////////////////
				int i,j = -1;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_services

void ParseLinesSelpawTypes::selpaw_system_types()
{
	//change path as you wish.
	/////////////////////////////////////////////////////////////
	path_selpaw = "./";
	path_to_be_written_selpaw = "./selpaw_system_types.txt";
	/////////////////////////////////////////////////////////////
	forward_slash = "/";
	cumma = ",";
	dir_selpaw.setPath(path);
	dir_name_selpaw = dir_selpaw.absPath();
	//cout << "dir_name_selpaw:" << dir_name_selpaw << endl;
	file_w_selpaw.setName(path_to_be_written_selpaw);
	/////////////////////////////////////////////////////////////
	dir_selpaw.setFilter( QDir::Files );
        dir_selpaw.setSorting( QDir::Name );
	//files = dir.entryList("*.if");
	files_selpaw = dir_selpaw.entryList("interfaces_system.txt");
	/////////////////////////////////////////////////////////////
	it_d_selpaw = files_selpaw.begin();
	if (file_w_selpaw.exists()) {
		file_w_selpaw.remove();
	}
	
	if ( file_w_selpaw.open( IO_WriteOnly | IO_Append ) ) {
		while(it_d_selpaw != files_selpaw.end()){
			name_selpaw = *it_d_selpaw;
			file_interface_name_selpaw = dir_name_selpaw + forward_slash + name_selpaw;
			//cout << "file_interface_name_selpaw:" << file_interface_name_selpaw << endl;
			QFile file_selpaw( file_interface_name_selpaw );
			if ( file_selpaw.open( IO_ReadOnly ) ) {
				//cout << "file_selpaw_opened" << endl;
			    QTextStream stream_selpaw( &file_selpaw );
				layer_name = "system";
				////////////////////////////////////////////
				QRegExp rx_interface("^[a-zA-Z]");
				QRegExp rx_if_file_name("^:");
				QRegExp rx_colon(":");
				QRegExp rx_if(".if");
				////////////////////////////////////////////
				int i,j = -1;
				while ( !stream_selpaw.atEnd() ) {
					line_analized = stream_selpaw.readLine(); // line of text excluding '\n'
					//cout << "line_analized:" << line_analized << endl;
					i = line_analized.find( rx_interface, 0);
					j = line_analized.find( rx_if_file_name, 0);
					if(i != -1){
						interface_name_this = line_analized;//this adds to lines. also append can be used
					}
					if(j != -1){
						line_analized = line_analized.replace(":","");		
						line_analized = line_analized.replace(".if","");		
						filename_this = line_analized;//this adds to lines. also append can be used
					}
					if((i == -1)&&(j == -1)){
						line_analized = line_analized.stripWhiteSpace();
						lines_selpaw += layer_name + cumma + filename_this + cumma + interface_name_this + cumma + line_analized + cumma;
					}
				}
				QTextStream stream_w_selpaw( &file_w_selpaw );
				for ( it_selpaw = lines_selpaw.begin(); it_selpaw != lines_selpaw.end(); ++it_selpaw ){
					stream_w_selpaw << *it_selpaw << "\n";
				}
				file_selpaw.close();
				lines_selpaw.clear();
				++it_d_selpaw;
			}else{
				//do nothing
			}
		}
	}
	file_w_selpaw.close();
}//end-selpaw_system
ParseLinesSelpawTypes::~ParseLinesSelpawTypes(){}
